<?php

namespace OrganizationsManagement\Repository;


use Doctrine\ORM\EntityManager;

class ServerMnemonic
{
    /** @var EntityManager **/
    protected $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findServerMnemonicByProductServerIds($productId, $serverId, $filters)
    {
        $query = <<<SQL
          SELECT *
          FROM (SELECT  NVL(MN.SERVER_ID,SMN.SERVER_ID) AS SERVER_ID, NVL(MN.MNEMONIC,SMN.MNEMONIC) AS MNEMONIC,
                    NVL(MN.LABEL,SMN.LABEL) AS LABEL, 
                    NVL(MN.MNEMONIC_ID,SMN.MNEMONIC_ID) AS MNEMONIC_ID,
                    (CASE WHEN NVL(MN.VALUE,SMN.VALUE) IS NOT NULL THEN NVL(MN.VALUE,SMN.VALUE)
                         WHEN (NVL(MN.VALUE,SMN.VALUE) IS NULL) AND (MN.DEFAULT_VALUE IS NOT NULL) THEN MN.DEFAULT_VALUE
                    ELSE NVL(MN.VALUE,SMN.VALUE) END) AS VALUE,
                    (CASE WHEN (NVL(MN.VALUE,SMN.VALUE) IS NOT NULL) AND (MN.DEFAULT_VALUE IS NOT NULL) THEN 'M'
                         WHEN NVL(MN.VALUE,SMN.VALUE) IS NOT NULL THEN 'N'
                         WHEN (NVL(MN.VALUE,SMN.VALUE) IS NULL) AND (MN.DEFAULT_VALUE IS NOT NULL) THEN 'Y'
                    ELSE 'N' END) AS IS_DEFAULT_VALUE
              FROM (SELECT SER.ID AS SERVER_ID, SER.NAME, PMN.MNEMONIC, PMN.MNEMONIC_LABEL AS LABEL,
                           PRO.NAME AS PRODUCT_NAME, SEM.VALUE, PMN.MNEMONIC_ID, PMN.DEFAULT_VALUE, PRO.ID AS PRODUCT_ID
                      FROM PRODUCT_SERVER PSE
                      JOIN SERVER SER ON (SER.ID = PSE.SERVER_ID)
                      JOIN (SELECT PFI.PRODUCT_ID, MNE.DEFAULT_VALUE, MNE.MNEMONIC, MNE.LABEL AS MNEMONIC_LABEL, MNE.ID AS MNEMONIC_ID, PFI.TYPE,
                                    'P' AS TYPE_SERVER_USER
                              FROM PRODUCT_FILES_MNEMONIC PFM
                              JOIN MNEMONIC MNE ON (MNE.ID = PFM.MNEMONIC_ID)
                              JOIN PRODUCT_FILES PFI ON (PFI.ID = PFM.PRODUCT_FILES_ID)
                             WHERE PFI.TYPE IN('L','K','J','I')) PMN ON (PMN.PRODUCT_ID = PSE.PRODUCT_ID AND PMN.TYPE_SERVER_USER = PSE.USETYPE)
                      JOIN PRODUCT PRO ON (PRO.ID = PMN.PRODUCT_ID AND PRO.IS_ACTIVE = :IS_ACTIVE)
                 LEFT JOIN SERVER_MNEMONIC SEM ON (SEM.SERVER_ID = SER.ID AND SEM.MNEMONIC_ID = PMN.MNEMONIC_ID)
                 LEFT JOIN MNEMONIC MNE ON (MNE.ID = SEM.MNEMONIC_ID)
                     WHERE SER.ID = :SERVER_ID
                  GROUP BY SER.ID, SER.NAME, PMN.MNEMONIC, PMN.MNEMONIC_LABEL, PRO.NAME, PRO.ID,
                             SEM.VALUE, PMN.MNEMONIC_ID, PMN.DEFAULT_VALUE
                  ORDER BY PMN.MNEMONIC_ID)MN
                 FULL JOIN (SELECT SEM.SERVER_ID, MNE.MNEMONIC, MNE.LABEL, SEM.VALUE, SEM.MNEMONIC_ID
                              FROM SERVER_MNEMONIC SEM
                        LEFT JOIN MNEMONIC MNE ON (SEM.MNEMONIC_ID = MNE.ID)
                            WHERE SEM.SERVER_ID = :SERVER_ID) SMN ON (SMN.MNEMONIC_ID = MN.MNEMONIC_ID)
                    WHERE MN.PRODUCT_ID = 1776                
                 GROUP BY MN.SERVER_ID, MN.NAME, MN.MNEMONIC, MN.LABEL, MN.VALUE, MN.MNEMONIC_ID,
                         SMN.MNEMONIC_ID, SMN.VALUE, SMN.LABEL, SMN.MNEMONIC, SMN.SERVER_ID,
                         MN.PRODUCT_NAME, MN.DEFAULT_VALUE, MN.PRODUCT_ID)
           WHERE 1 = 1
           $filters
SQL;
        $param = array(
            "PRODUCT_ID" => $productId,
            "SERVER_ID" => $serverId,
            "IS_ACTIVE" => 'Y'
        );
        return $this->entityManager->getConnection()->fetchAll($query, $param);
    }
} 