# API Módulos Contratados
Retorna ids dos módulos do produto informado.
## Produto requisitado:

| Nome                     | url            | uri                                      |
|--------------------------|----------------|------------------------------------------|
| Organizations Management | om.teknisa.com | https://om.teknisa.com/backend/index.php |

## Verbos HTTPs permitidos:
GET

## Informações de acesso:

API de consulta com rota(s) pública(s)
### Rotas

```
/api/contracted_modules
```
Método `GET`

**Parâmetros**

| Parâmetro         | Tipo         | Descrição                                 |
|-------------------|--------------|-------------------------------------------|
| ORGANIZATION_ID   | int - String | Id da organização (Tabela ORGANIZACAO)    |
| PRODUCT_ID        | int - String | Id do produto (Tabela PRODUCT)            |
| FILTER_DTVALIDADE | String       | Filtrar data de validade (Default 'N')    |

###### Exemplo de uso em `php`:

```php
<?php

$url = "https://om.teknisa.com/backend/index.php/api/contracted_modules";
$header[] = 'Content-Type: application/json';
$dataArray = [ 'ORGANIZATION_ID' => 20, 'PRODUCT_ID' => 161 ];
// Caso deseje que não retorne módulos com todos os elementos inadimplentes:
// $dataArray = [ 'ORGANIZATION_ID' => 20, 'PRODUCT_ID' => 161, 'FILTER_DTVALIDADE' => 'S' ];
$data = http_build_query($dataArray);
$getUrl = $url."?".$data;

$curl = curl_init();

curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
curl_setopt($curl, CURLOPT_URL, $getUrl);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

$output = curl_exec($curl);
$output = json_decode($output, true);
$error = curl_error($curl);

if ($error) {
    var_dump($error);
} else {
    var_dump($output);
}

curl_close($curl);
```

### Retorno

```php
array(1) {
  ["dataset"]=>
  array(1) {
    ["data"]=>
    array(3) {
      [0]=>
      string(3) "161"
      [1]=>
      string(4) "2272"
      [2]=>
      string(4) "1874"
    }
  }
}
```
